#! /usr/local/bin/guile \
-e main -s
!#

;;  Copyright 2001, Evan Prodromou <evan@prodromou.san-francisco.ca.us>.

;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; either version 2 of the License, or
;;  (at your option) any later version.

;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.

;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;; USAGE: server.scm [port] [dir] 

(use-modules (oop goops)
             (net http message)
             (net http server))

(define-class <file-server> (<http-server>)
  (dir #:accessor dir #:init-keyword #:dir)
  (name #:accessor name #:init-value "(my-file-server)/0.1" #:init-keyword #:name))

(define-method (on-get (server <file-server>) (req <http-request>))
  (let* ((fname (string-append (dir server) (uri req)))
         (fsize (stat:size (stat fname)))
         (infile (open-file fname "r"))
         (resp (make <http-response> 
                  #:code 200
                  #:status "OK"
                  #:headers (list (cons "Content-Length" (format #f "~A" fsize)))
                  #:content infile)))
    resp))
  
(define (main args)
  (let* ((dir (list-ref args 2))
         (port (string->number (list-ref args 1)))
         (server (make <file-server> #:dir dir #:port port)))
    (run server)))

